unit frminspect;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons;

type
  TInspectForm = class(TForm)
    BOK: TButton;
    BCancel: TButton;
    CBVisible: TCheckBox;
    CBAlign: TComboBox;
    CBLayout: TComboBox;
    ECaption: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure BOKClick(Sender: TObject);
    procedure InspectFormShow(Sender: TObject);
  private
    Flabel: TLabel;
    procedure SetLabel(const AValue: TLabel);
    { private declarations }
    Procedure LoadProps;
    Procedure SaveProps;
  public
    { public declarations }
    Property TheLabel : TLabel Read Flabel Write SetLabel;
  end; 

var
  InspectForm: TInspectForm;

implementation

{ TInspectForm }

procedure TInspectForm.InspectFormShow(Sender: TObject);
begin
end;

procedure TInspectForm.BOKClick(Sender: TObject);
begin
  SaveProps;
end;

procedure TInspectForm.SetLabel(const AValue: TLabel);
begin
  Flabel:=AValue;
  If Assigned(Flabel) then
    LoadProps;

end;

procedure TInspectForm.LoadProps;
begin
  CBAlign.ItemIndex:=Ord(FLabel.AlignMent);
  CBLayout.ItemIndex:=Ord(FLabel.Layout);
  ECaption.Text:=FLabel.Caption;
  CBVisible.Checked:=FLabel.Visible;
end;

procedure TInspectForm.SaveProps;
begin
  FLabel.Alignment:=TAlignMent(CBAlign.ItemIndex);
  FLabel.Layout:=TTextLayout(CBLayout.ItemIndex);
  FLabel.Caption:=ECaption.Text;
  Flabel.Visible:=CBVisible.Checked;
end;

initialization
  {$I frminspect.lrs}

end.

