unit mdactrls;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs,
  rttictrls, model;

type
  TRTTIAgent = Class(TDataAgent)
  Private
    FLink : TCustompropertyLink;
  Public
    Constructor Create(AOwner : TComponent; Link : TCustomPropertyLink);
    Procedure SetEntity(AEntity : TEntity); override;
  end;
  
  TMDAEdit = class(TTICustomEdit)
  private
    FModelLink : TDataAgent;
    function GetModel: TModel;
    function GetPropertyName: String;
    procedure SetModel(const AValue: TModel);
    procedure SetPropertyName(const AValue: String);
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    Constructor Create(AOwner : TComponent); override;
    Destructor Destroy; override;
  published
    { Published declarations }
    Property Model : TModel Read GetModel Write SetModel;
    Property PropertyName : String Read GetPropertyName Write SetPropertyName;
  end;

  TMDACalendar = class(TTICustomCalendar)
  private
    FModelLink : TDataAgent;
    function GetModel: TModel;
    function GetPropertyName: String;
    procedure SetModel(const AValue: TModel);
    procedure SetPropertyName(const AValue: String);
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    Constructor Create(AOwner : TComponent); override;
    Destructor Destroy; override;
  published
    { Published declarations }
    Property Model : TModel Read GetModel Write SetModel;
    Property PropertyName : String Read GetPropertyName Write SetPropertyName;
  end;

procedure Register;

implementation

uses typinfo;

procedure Register;
begin
  RegisterComponents('MDA',[TMDAEdit,TMDACalendar]);
end;

{ TRTTIAgent }

constructor TRTTIAgent.Create(AOwner: TComponent; Link: TCustomPropertyLink);
begin
  Inherited Create(AOWner);
  Flink:=Link;
end;

procedure TRTTIAgent.SetEntity(AEntity: TEntity);

begin
  If Assigned(Flink) then
    FLink.TIObject:=AEntity;
end;

{ TMDAEdit }

function TMDAEdit.GetPropertyName: String;
begin
  Result:=Link.TIPropertyName;
end;

function TMDAEdit.GetModel: TModel;
begin
  Result:=FModelLink.Model as TModel;
end;

procedure TMDAEdit.SetModel(const AValue: TModel);
begin
  FModelLink.Model:=AValue;
end;

procedure TMDAEdit.SetPropertyName(const AValue: String);
begin
  Link.TIPropertyName:=AValue;
end;


constructor TMDAEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FModelLink:=TRTTIAgent.Create(Self,Self.Link);
end;

destructor TMDAEdit.Destroy;
begin
  FreeAndNil(FModelLink);
  inherited Destroy;
end;

{ TMDACalendar}

function TMDACalendar.GetPropertyName: String;
begin
  Result:=Link.TIPropertyName;
end;

function TMDACalendar.GetModel: TModel;
begin
  Result:=FModelLink.Model as TModel;
end;

procedure TMDACalendar.SetModel(const AValue: TModel);
begin
  FModelLink.Model:=AValue;
end;

procedure TMDACalendar.SetPropertyName(const AValue: String);
begin
  Link.TIPropertyName:=AValue;
end;

constructor TMDACalendar.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FModelLink:=TRTTIAgent.Create(Self,Self.Link);
end;

destructor TMDACalendar.Destroy;
begin
  FreeAndNil(FModelLink);
  inherited Destroy;
end;


end.
