unit frmmain; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, Buttons,
  StdCtrls, Calendar,model;

type
  TMainForm = class(TForm)
    BNew: TButton;
    BLoad: TButton;
    CBirthDay: TCalendar;
    EFirstName: TEdit;
    ELastName: TEdit;
    EID: TEdit;
    LDateOfBirth: TLabel;
    LELastName: TLabel;
    LEFirstName: TLabel;
    FModel: TModel;
    procedure BLoadClick(Sender: TObject);
    procedure BNewClick(Sender: TObject);
    procedure MainFormCreate(Sender: TObject);
  private
    { private declarations }
    FPerson : TPerson;
  public
    { public declarations }
    Procedure ShowPerson;
    Procedure SavePerson;
  end;

var
  MainForm: TMainForm;

implementation


{ TMainForm }

procedure TMainForm.BNewClick(Sender: TObject);
begin
  If Assigned(FPerson) then
    begin
    SavePerson;
    FreeAndNil(FPerson);
    end;
  FPerson:=FModel.CreateNewInstance('TPerson') as TPerson;
  ShowPerson;
end;

procedure TMainForm.BLoadClick(Sender: TObject);
begin
  If Assigned(FPerson) then
    begin
    SavePerson;
    FreeAndNil(FPerson);
    end;
  FPerson:=FModel.CreateInstanceFromID('TPerson',EID.Text) as TPerson;
  ShowPerson;
end;

procedure TMainForm.MainFormCreate(Sender: TObject);
begin
{
  If assigned(CBirthday) then
    ShowMessage('Birthday assigned');
  With CBirthday do
    If Visible then
      begin
      If Parent<>Self then
        ShowMessage('Parent Wrong')
      else
        ShowMessage('Parent OK');

      ShowMessage(Format('Birthday visible %d,%d %dx%d',[top, left, width, height]));
      Paint;
      end;
}
end;

procedure TMainForm.ShowPerson;

begin
  If Assigned(FPerson) then
    begin
    EFirstName.Text:=FPerson.FirstName;
    ELastName.Text:=FPerson.LastName;
    CBirthDay.DateTime:=FPerson.BirthDay;
    end
  else
    begin
    EFirstName.Text:='';
    ELastName.Text:='';
    CBirthDay.DateTime:=date;
    end;
end;

procedure TMainForm.SavePerson;

begin
  If Assigned(FPerson) then
    begin
    FPerson.FirstName:=EFirstName.Text;
    FPerson.LastName:=ELastName.Text;
    FPerson.BirthDay:=CBirthDay.DateTime;
    end;
end;

initialization
  {$I frmmain.lrs}

end.

